<?php

namespace App\Controller;

use App\Connexion;
use App\Gateway\TacticInfoGateway;
use App\Http\HttpResponse;
use App\Http\ViewHttpResponse;
use App\Model\TacticModel;
use App\Session\SessionHandle;

class UserController extends VisitorController {
    public function home(): HttpResponse {
        return ViewHttpResponse::twig("home.twig", []);
    }

    public function view(int $id, SessionHandle $session): HttpResponse {
        $model = new TacticModel(new TacticInfoGateway(new Connexion(get_database())));
        return (new Sub\VisualizerController($model))->visualize($id, $session);
    }

    public function edit(int $id, SessionHandle $session): HttpResponse {
        $model = new TacticModel(new TacticInfoGateway(new Connexion(get_database())));
        return (new Sub\EditorController($model))->edit($id, $session);
    }

    public function create(SessionHandle $session): HttpResponse {
        $model = new TacticModel(new TacticInfoGateway(new Connexion(get_database())));
        return (new Sub\EditorController($model))->createNew($session);
    }
}
