<?php

namespace App\Session;

use App\Data\Account;

class PhpSessionHandle implements MutableSessionHandle {
    public static function init(): SessionHandle {
        if (session_status() !== PHP_SESSION_NONE) {
            throw new \Exception("A php session is already started !");
        }
        session_start();
        return new PhpSessionHandle();
    }

    public function getAccount(): ?Account {
        return $_SESSION["account"] ?? null;
    }

    public function setAccount(Account $account): void {
        $_SESSION["account"] = $account;
    }
}
